#!/bin/zsh

clingover="$(python3 -m clingo --version | sed -n 's/pyclingo version \([^.]*\.[^.]*\)\..*/\1/p')"

pdoc3 -c http_server=True --html -f clingo clingox
cat << EOF | base64 -d | zcat > html/index.html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sed -i '/^<script>$/{:a;N;/<\/script>$/!ba};/window\.location\.reload()/d' ./html/**/*(.)
sed -i 's|href="/|href="https://potassco.org/clingo/python-api/'${clingover}'/|g' ./html/**/*(.)
rsync -av --delete ./html/ ${HOME}/git/potassco/potassco.github.io/clingo/python-api/${clingover}/
